I=(S=Tetrahedra.DrawExposePoint = function(){
}).prototype;

I.Draw = function()
{
    var temp_unique7523 = new Uno.Float4;
    var temp_unique7522 = new Uno.Float4;
    var temp_unique7521 = new Uno.Float4;
    var temp_unique7516 = new Uno.Float4;
    var temp_unique7515 = new Uno.Float4;
    var temp_unique7514 = new Uno.Float4;
    var temp_unique7504 = new Uno.Float4;
    var temp_unique7503 = new Uno.Float4;
    var temp_unique7502 = new Uno.Float4;
    var temp_unique7497 = new Uno.Float4;
    var temp_unique7496 = new Uno.Float4;
    var temp_unique7495 = new Uno.Float4;
    {
        var World_3_30_1 = this.parent.Transform.Absolute();
        var World_9_0_1 = Uno.Matrix.Mul(Uno.Float4x4.$0(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 62.44581, 1.0), World_3_30_1);
        var World_9_1_1 = Uno.Matrix.Mul(Uno.Float4x4.$0(1.0, 0.0, 0.0, 0.0, 0.0, -4.371139e-08, -1.0, 0.0, 0.0, 1.0, -4.371139e-08, 0.0, 0.0, 0.0, 0.0, 1.0), World_9_0_1);
        var Camera_5_0_1 = Uno.Application.Camera();
        var View_3_13_1 = Camera_5_0_1.View();
        var WorldInverse_3_31_1 = Uno.Matrix.Invert_1(World_9_1_1);
        var WorldInverseTranspose_3_32_1 = Uno.Matrix.Transpose(WorldInverse_3_31_1);
        gl.useProgram(this.Draw_Sphere01_Drawable0_prog);
        gl.colorMask(true, true, true, true);
        gl.depthMask(true);
        gl.disable(3042);
        gl.cullFace(Uno.Graphics.OpenGL.Interop.PolygonFaceToGLenum(2));
        gl.enable(2884);
        gl.enable(2929);
        gl.frontFace(Uno.Graphics.OpenGL.Interop.PolygonWindingToGLenum(1));
        gl.uniformMatrix4fv(this.Draw_Sphere01_Drawable0_World_9_1_1_FZrFIILMdL, false, uglFloat4x4(Uno.Matrix.Mul(Uno.Float4x4.$0(1.0, 0.0, 0.0, 0.0, 0.0, -4.371139e-08, -1.0, 0.0, 0.0, 1.0, -4.371139e-08, 0.0, 0.0, 0.0, 0.0, 1.0), World_9_0_1)));
        gl.uniformMatrix4fv(this.Draw_Sphere01_Drawable0_View_3_13_1_VXDQJnChpK, false, uglFloat4x4(Camera_5_0_1.View()));
        gl.uniformMatrix4fv(this.Draw_Sphere01_Drawable0_Proj_3_14_1_VHbgIGrfBX, false, uglFloat4x4(Camera_5_0_1.Proj()));
        gl.uniformMatrix3fv(this.Draw_Sphere01_Drawable0_World3x3_3_33_1_iQMuyLIIZu, false, uglFloat3x3(Uno.Float3x3.$1((temp_unique7495 = WorldInverseTranspose_3_32_1.indexer(0), Uno.Float3.$1(temp_unique7495.X, temp_unique7495.Y, temp_unique7495.Z)), (temp_unique7496 = WorldInverseTranspose_3_32_1.indexer(1), Uno.Float3.$1(temp_unique7496.X, temp_unique7496.Y, temp_unique7496.Z)), (temp_unique7497 = WorldInverseTranspose_3_32_1.indexer(2), Uno.Float3.$1(temp_unique7497.X, temp_unique7497.Y, temp_unique7497.Z)))));
        gl.uniformMatrix3fv(this.Draw_Sphere01_Drawable0_View3x3_3_29_1_agvCMOYxxm, false, uglFloat3x3(Uno.Float3x3.$1((temp_unique7502 = View_3_13_1.indexer(0), Uno.Float3.$1(temp_unique7502.X, temp_unique7502.Y, temp_unique7502.Z)), (temp_unique7503 = View_3_13_1.indexer(1), Uno.Float3.$1(temp_unique7503.X, temp_unique7503.Y, temp_unique7503.Z)), (temp_unique7504 = View_3_13_1.indexer(2), Uno.Float3.$1(temp_unique7504.X, temp_unique7504.Y, temp_unique7504.Z)))));
        gl.activeTexture(33984);
        gl.bindTexture(3553, this.Draw_Sphere01_Drawable0_textureMap_12_4_1_OZKksorOxN_val.GLHandle());
        gl.uniform1i(this.Draw_Sphere01_Drawable0_textureMap_12_4_1_OZKksorOxN, 0);
        gl.activeTexture(33985);
        gl.bindTexture(3553, this.Draw_Sphere01_Drawable0_envMap_12_5_1_hrMnlyQnpX_val.GLHandle());
        gl.uniform1i(this.Draw_Sphere01_Drawable0_envMap_12_5_1_hrMnlyQnpX, 1);
        gl.activeTexture(33986);
        gl.bindTexture(3553, this.Draw_Sphere01_Drawable0_envMap2_12_6_1_kqhRmYbAZX_val.GLHandle());
        gl.uniform1i(this.Draw_Sphere01_Drawable0_envMap2_12_6_1_kqhRmYbAZX, 2);
        gl.enableVertexAttribArray(this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn);
        gl.bindBuffer(34962, this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn_vbo.GLHandle());
        gl.vertexAttribPointer(this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn, 3, 5126, false, 0, 0);
        gl.enableVertexAttribArray(this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ);
        gl.bindBuffer(34962, this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ_vbo.GLHandle());
        gl.vertexAttribPointer(this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ, 4, 5120, true, 0, 0);
        gl.bindBuffer(34963, this.Draw_Sphere01_Drawable0_ibo.GLHandle());
        gl.drawElements(Uno.Graphics.OpenGL.Interop.PrimitiveTypeToGLenum(0), 360, 5123, 0);
        gl.disableVertexAttribArray(this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn);
        gl.disableVertexAttribArray(this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ);
        Uno.Application.IncrementDrawCallCounter(360);
    }

    {
        var World_3_30_0 = this.parent.Transform.Absolute();
        var World_9_0_0 = Uno.Matrix.Mul(Uno.Float4x4.$0(1.0, 0.0, 0.0, 0.0, 0.0, -4.371139e-08, -1.0, 0.0, 0.0, 1.0, -4.371139e-08, 0.0, 0.0, 0.0, 0.0, 1.0), World_3_30_0);
        var Camera_5_0_0 = Uno.Application.Camera();
        var View_3_13_0 = Camera_5_0_0.View();
        var WorldInverse_3_31_0 = Uno.Matrix.Invert_1(World_9_0_0);
        var WorldInverseTranspose_3_32_0 = Uno.Matrix.Transpose(WorldInverse_3_31_0);
        gl.useProgram(this.Draw_Cone01_Drawable0_prog);
        gl.colorMask(true, true, true, true);
        gl.depthMask(true);
        gl.disable(3042);
        gl.cullFace(Uno.Graphics.OpenGL.Interop.PolygonFaceToGLenum(2));
        gl.enable(2884);
        gl.enable(2929);
        gl.frontFace(Uno.Graphics.OpenGL.Interop.PolygonWindingToGLenum(1));
        gl.uniformMatrix4fv(this.Draw_Cone01_Drawable0_World_9_0_0_zzhdRHxQKy, false, uglFloat4x4(Uno.Matrix.Mul(Uno.Float4x4.$0(1.0, 0.0, 0.0, 0.0, 0.0, -4.371139e-08, -1.0, 0.0, 0.0, 1.0, -4.371139e-08, 0.0, 0.0, 0.0, 0.0, 1.0), World_3_30_0)));
        gl.uniformMatrix4fv(this.Draw_Cone01_Drawable0_View_3_13_0_tCtqMZWFad, false, uglFloat4x4(Camera_5_0_0.View()));
        gl.uniformMatrix4fv(this.Draw_Cone01_Drawable0_Proj_3_14_0_IBdiCRmiDM, false, uglFloat4x4(Camera_5_0_0.Proj()));
        gl.uniformMatrix3fv(this.Draw_Cone01_Drawable0_World3x3_3_33_0_GzPOFcYuVI, false, uglFloat3x3(Uno.Float3x3.$1((temp_unique7514 = WorldInverseTranspose_3_32_0.indexer(0), Uno.Float3.$1(temp_unique7514.X, temp_unique7514.Y, temp_unique7514.Z)), (temp_unique7515 = WorldInverseTranspose_3_32_0.indexer(1), Uno.Float3.$1(temp_unique7515.X, temp_unique7515.Y, temp_unique7515.Z)), (temp_unique7516 = WorldInverseTranspose_3_32_0.indexer(2), Uno.Float3.$1(temp_unique7516.X, temp_unique7516.Y, temp_unique7516.Z)))));
        gl.uniformMatrix3fv(this.Draw_Cone01_Drawable0_View3x3_3_29_0_ldElqMfXuE, false, uglFloat3x3(Uno.Float3x3.$1((temp_unique7521 = View_3_13_0.indexer(0), Uno.Float3.$1(temp_unique7521.X, temp_unique7521.Y, temp_unique7521.Z)), (temp_unique7522 = View_3_13_0.indexer(1), Uno.Float3.$1(temp_unique7522.X, temp_unique7522.Y, temp_unique7522.Z)), (temp_unique7523 = View_3_13_0.indexer(2), Uno.Float3.$1(temp_unique7523.X, temp_unique7523.Y, temp_unique7523.Z)))));
        gl.activeTexture(33984);
        gl.bindTexture(3553, this.Draw_Cone01_Drawable0_textureMap_13_4_0_zyaIGHcelM_val.GLHandle());
        gl.uniform1i(this.Draw_Cone01_Drawable0_textureMap_13_4_0_zyaIGHcelM, 0);
        gl.activeTexture(33985);
        gl.bindTexture(3553, this.Draw_Cone01_Drawable0_envMap_13_5_0_GAdnSndlEw_val.GLHandle());
        gl.uniform1i(this.Draw_Cone01_Drawable0_envMap_13_5_0_GAdnSndlEw, 1);
        gl.activeTexture(33986);
        gl.bindTexture(3553, this.Draw_Cone01_Drawable0_envMap2_13_6_0_WhPbTTohYp_val.GLHandle());
        gl.uniform1i(this.Draw_Cone01_Drawable0_envMap2_13_6_0_WhPbTTohYp, 2);
        gl.enableVertexAttribArray(this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS);
        gl.bindBuffer(34962, this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS_vbo.GLHandle());
        gl.vertexAttribPointer(this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS, 3, 5126, false, 0, 0);
        gl.enableVertexAttribArray(this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe);
        gl.bindBuffer(34962, this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe_vbo.GLHandle());
        gl.vertexAttribPointer(this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe, 4, 5120, true, 0, 0);
        gl.bindBuffer(34963, this.Draw_Cone01_Drawable0_ibo.GLHandle());
        gl.drawElements(Uno.Graphics.OpenGL.Interop.PrimitiveTypeToGLenum(0), 204, 5123, 0);
        gl.disableVertexAttribArray(this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS);
        gl.disableVertexAttribArray(this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe);
        Uno.Application.IncrementDrawCallCounter(204);
    }
};

S.$0 = function(parent, $this) {
    if (!$this) $this = new Tetrahedra.DrawExposePoint;
    {
        $this.parent = parent;
    }

    {
        $this.Draw_Sphere01_Drawable0_ibo = Uno.ResourceManager.GetResource("IndexBuffer_BWmBPwTxps");
        $this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn_vbo = Uno.ResourceManager.GetResource("VertexBuffer_mVFgaSRPFm");
        $this.Draw_Sphere01_Drawable0_textureMap_12_4_1_OZKksorOxN_val = Uno.ResourceManager.GetResource("textureMap_FdRcNFYYfw");
        $this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ_vbo = Uno.ResourceManager.GetResource("VertexBuffer_INbdfiOFeA");
        $this.Draw_Sphere01_Drawable0_envMap_12_5_1_hrMnlyQnpX_val = Uno.ResourceManager.GetResource("envMap_qFlfgRgAcd");
        $this.Draw_Sphere01_Drawable0_envMap2_12_6_1_kqhRmYbAZX_val = Uno.ResourceManager.GetResource("envMap2_okOmvBDYMN");
    }

    {
        $this.Draw_Cone01_Drawable0_ibo = Uno.ResourceManager.GetResource("IndexBuffer_wqnsPCZKeg");
        $this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS_vbo = Uno.ResourceManager.GetResource("VertexBuffer_KEdfOdcAJv");
        $this.Draw_Cone01_Drawable0_textureMap_13_4_0_zyaIGHcelM_val = Uno.ResourceManager.GetResource("textureMap_FdRcNFYYfw");
        $this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe_vbo = Uno.ResourceManager.GetResource("VertexBuffer_WStocqEJJu");
        $this.Draw_Cone01_Drawable0_envMap_13_5_0_GAdnSndlEw_val = Uno.ResourceManager.GetResource("envMap_qFlfgRgAcd");
        $this.Draw_Cone01_Drawable0_envMap2_13_6_0_WhPbTTohYp_val = Uno.ResourceManager.GetResource("envMap2_okOmvBDYMN");
    }

    $this.Draw_Sphere01_Drawable0_vs = uglCompileShader(35633, "Tetrahedra_DrawExposePoint_Draw_Sphere01_Drawable0_vs", "uniform mat4 World_9_1_1_FZrFIILMdL;\nuniform mat4 View_3_13_1_VXDQJnChpK;\nuniform mat4 Proj_3_14_1_VHbgIGrfBX;\nuniform mat3 World3x3_3_33_1_iQMuyLIIZu;\nuniform mat3 View3x3_3_29_1_agvCMOYxxm;\n\nvarying vec4 BinOpCallBinOpCall_mVWrPBsyqr;\nvarying vec2 BinOpCall_hJVmnJuiqn;\n\nattribute vec3 VertexPosition_EpDNeAMOWn;\nattribute vec4 VertexNormal_pCHNIUDWMQ;\n\nvoid main(void)\n{\n\tvec3 VertexPosition_10_5_1 = VertexPosition_EpDNeAMOWn;\n\tvec3 VertexPosition_12_2_1 = VertexPosition_EpDNeAMOWn * 0.8;\n\tvec3 WorldPosition_3_37_1 = (World_9_1_1_FZrFIILMdL * vec4(VertexPosition_12_2_1,1.)).xyz;\n\tvec3 ViewPosition_3_18_1 = (View_3_13_1_VXDQJnChpK * vec4(WorldPosition_3_37_1, 1.0)).xyz;\n\tvec4 ClipPosition_3_19_1 = Proj_3_14_1_VHbgIGrfBX * vec4(ViewPosition_3_18_1, 1.0);\n\tgl_Position = Proj_3_14_1_VHbgIGrfBX * vec4(ViewPosition_3_18_1, 1.0);\n\tBinOpCallBinOpCall_mVWrPBsyqr.xy = normalize(VertexPosition_12_2_1).xy * vec2(4.0);\n\tvec4 VertexNormal_10_9_1 = VertexNormal_pCHNIUDWMQ;\n\tvec3 WorldNormal_3_38_1 = normalize(World3x3_3_33_1_iQMuyLIIZu * VertexNormal_pCHNIUDWMQ.xyz);\n\tvec3 ViewNormal_3_39_1 = normalize(View3x3_3_29_1_agvCMOYxxm * WorldNormal_3_38_1);\n\tBinOpCallBinOpCall_mVWrPBsyqr.zw = (ViewNormal_3_39_1.xy * 0.5) + 0.5;\n\tBinOpCall_hJVmnJuiqn = (ViewNormal_3_39_1.zx * 0.5) + 0.5;\n}\n");
    $this.Draw_Sphere01_Drawable0_ps = uglCompileShader(35632, "Tetrahedra_DrawExposePoint_Draw_Sphere01_Drawable0_ps", "uniform sampler2D textureMap_12_4_1_OZKksorOxN;\nuniform sampler2D envMap_12_5_1_hrMnlyQnpX;\nuniform sampler2D envMap2_12_6_1_kqhRmYbAZX;\n\nvarying vec4 BinOpCallBinOpCall_mVWrPBsyqr;\nvarying vec2 BinOpCall_hJVmnJuiqn;\n\nvoid main(void)\n{\n\tvec4 diffuseColor_12_7_1 = texture2D(textureMap_12_4_1_OZKksorOxN, BinOpCallBinOpCall_mVWrPBsyqr.xy) * 0.5;\n\tvec4 PixelColor_12_8_1 = diffuseColor_12_7_1 + ((texture2D(envMap_12_5_1_hrMnlyQnpX, BinOpCallBinOpCall_mVWrPBsyqr.zw) + texture2D(envMap2_12_6_1_kqhRmYbAZX, BinOpCall_hJVmnJuiqn)) * (diffuseColor_12_7_1 + 0.4));\n\tvec4 PixelColor_12_9_1 = vec4(PixelColor_12_8_1.x * PixelColor_12_8_1.x, PixelColor_12_8_1.y * PixelColor_12_8_1.y, PixelColor_12_8_1.z * PixelColor_12_8_1.z, 2.0) * 0.5;\n\tgl_FragColor = vec4(PixelColor_12_8_1.x * PixelColor_12_8_1.x, PixelColor_12_8_1.y * PixelColor_12_8_1.y, PixelColor_12_8_1.z * PixelColor_12_8_1.z, 2.0) * 0.5;\n}\n");
    $this.Draw_Sphere01_Drawable0_prog = uglLinkProgram($this.Draw_Sphere01_Drawable0_vs, $this.Draw_Sphere01_Drawable0_ps);
    $this.Draw_Sphere01_Drawable0_VertexPosition_EpDNeAMOWn = gl.getAttribLocation($this.Draw_Sphere01_Drawable0_prog, "VertexPosition_EpDNeAMOWn");
    $this.Draw_Sphere01_Drawable0_VertexNormal_pCHNIUDWMQ = gl.getAttribLocation($this.Draw_Sphere01_Drawable0_prog, "VertexNormal_pCHNIUDWMQ");
    $this.Draw_Sphere01_Drawable0_World_9_1_1_FZrFIILMdL = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "World_9_1_1_FZrFIILMdL");
    $this.Draw_Sphere01_Drawable0_View_3_13_1_VXDQJnChpK = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "View_3_13_1_VXDQJnChpK");
    $this.Draw_Sphere01_Drawable0_Proj_3_14_1_VHbgIGrfBX = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "Proj_3_14_1_VHbgIGrfBX");
    $this.Draw_Sphere01_Drawable0_World3x3_3_33_1_iQMuyLIIZu = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "World3x3_3_33_1_iQMuyLIIZu");
    $this.Draw_Sphere01_Drawable0_View3x3_3_29_1_agvCMOYxxm = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "View3x3_3_29_1_agvCMOYxxm");
    $this.Draw_Sphere01_Drawable0_textureMap_12_4_1_OZKksorOxN = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "textureMap_12_4_1_OZKksorOxN");
    $this.Draw_Sphere01_Drawable0_envMap_12_5_1_hrMnlyQnpX = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "envMap_12_5_1_hrMnlyQnpX");
    $this.Draw_Sphere01_Drawable0_envMap2_12_6_1_kqhRmYbAZX = gl.getUniformLocation($this.Draw_Sphere01_Drawable0_prog, "envMap2_12_6_1_kqhRmYbAZX");
    $this.Draw_Cone01_Drawable0_vs = uglCompileShader(35633, "Tetrahedra_DrawExposePoint_Draw_Cone01_Drawable0_vs", "uniform mat4 World_9_0_0_zzhdRHxQKy;\nuniform mat4 View_3_13_0_tCtqMZWFad;\nuniform mat4 Proj_3_14_0_IBdiCRmiDM;\nuniform mat3 World3x3_3_33_0_GzPOFcYuVI;\nuniform mat3 View3x3_3_29_0_ldElqMfXuE;\n\nvarying vec4 BinOpCallBinOpCall_tMpftWzxtV;\nvarying vec2 BinOpCall_kGpfOfvBWr;\n\nattribute vec3 VertexPosition_hjhctziHRS;\nattribute vec4 VertexNormal_vomYYVBKJe;\n\nvoid main(void)\n{\n\tvec3 VertexPosition_10_5_0 = VertexPosition_hjhctziHRS;\n\tvec3 VertexPosition_13_2_0 = VertexPosition_hjhctziHRS * 0.8;\n\tvec3 WorldPosition_3_37_0 = (World_9_0_0_zzhdRHxQKy * vec4(VertexPosition_13_2_0,1.)).xyz;\n\tvec3 ViewPosition_3_18_0 = (View_3_13_0_tCtqMZWFad * vec4(WorldPosition_3_37_0, 1.0)).xyz;\n\tvec4 ClipPosition_3_19_0 = Proj_3_14_0_IBdiCRmiDM * vec4(ViewPosition_3_18_0, 1.0);\n\tgl_Position = Proj_3_14_0_IBdiCRmiDM * vec4(ViewPosition_3_18_0, 1.0);\n\tBinOpCallBinOpCall_tMpftWzxtV.xy = normalize(VertexPosition_13_2_0).xy * vec2(4.0);\n\tvec4 VertexNormal_10_9_0 = VertexNormal_vomYYVBKJe;\n\tvec3 WorldNormal_3_38_0 = normalize(World3x3_3_33_0_GzPOFcYuVI * VertexNormal_vomYYVBKJe.xyz);\n\tvec3 ViewNormal_3_39_0 = normalize(View3x3_3_29_0_ldElqMfXuE * WorldNormal_3_38_0);\n\tBinOpCallBinOpCall_tMpftWzxtV.zw = (ViewNormal_3_39_0.xy * 0.5) + 0.5;\n\tBinOpCall_kGpfOfvBWr = (ViewNormal_3_39_0.zx * 0.5) + 0.5;\n}\n");
    $this.Draw_Cone01_Drawable0_ps = uglCompileShader(35632, "Tetrahedra_DrawExposePoint_Draw_Cone01_Drawable0_ps", "uniform sampler2D textureMap_13_4_0_zyaIGHcelM;\nuniform sampler2D envMap_13_5_0_GAdnSndlEw;\nuniform sampler2D envMap2_13_6_0_WhPbTTohYp;\n\nvarying vec4 BinOpCallBinOpCall_tMpftWzxtV;\nvarying vec2 BinOpCall_kGpfOfvBWr;\n\nvoid main(void)\n{\n\tvec4 diffuseColor_13_7_0 = texture2D(textureMap_13_4_0_zyaIGHcelM, BinOpCallBinOpCall_tMpftWzxtV.xy) * 0.5;\n\tvec4 PixelColor_13_8_0 = diffuseColor_13_7_0 + ((texture2D(envMap_13_5_0_GAdnSndlEw, BinOpCallBinOpCall_tMpftWzxtV.zw) + texture2D(envMap2_13_6_0_WhPbTTohYp, BinOpCall_kGpfOfvBWr)) * (diffuseColor_13_7_0 + 0.4));\n\tvec4 PixelColor_13_9_0 = vec4(PixelColor_13_8_0.x * PixelColor_13_8_0.x, PixelColor_13_8_0.y * PixelColor_13_8_0.y, PixelColor_13_8_0.z * PixelColor_13_8_0.z, 2.0) * 0.5;\n\tgl_FragColor = vec4(PixelColor_13_8_0.x * PixelColor_13_8_0.x, PixelColor_13_8_0.y * PixelColor_13_8_0.y, PixelColor_13_8_0.z * PixelColor_13_8_0.z, 2.0) * 0.5;\n}\n");
    $this.Draw_Cone01_Drawable0_prog = uglLinkProgram($this.Draw_Cone01_Drawable0_vs, $this.Draw_Cone01_Drawable0_ps);
    $this.Draw_Cone01_Drawable0_VertexPosition_hjhctziHRS = gl.getAttribLocation($this.Draw_Cone01_Drawable0_prog, "VertexPosition_hjhctziHRS");
    $this.Draw_Cone01_Drawable0_VertexNormal_vomYYVBKJe = gl.getAttribLocation($this.Draw_Cone01_Drawable0_prog, "VertexNormal_vomYYVBKJe");
    $this.Draw_Cone01_Drawable0_World_9_0_0_zzhdRHxQKy = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "World_9_0_0_zzhdRHxQKy");
    $this.Draw_Cone01_Drawable0_View_3_13_0_tCtqMZWFad = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "View_3_13_0_tCtqMZWFad");
    $this.Draw_Cone01_Drawable0_Proj_3_14_0_IBdiCRmiDM = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "Proj_3_14_0_IBdiCRmiDM");
    $this.Draw_Cone01_Drawable0_World3x3_3_33_0_GzPOFcYuVI = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "World3x3_3_33_0_GzPOFcYuVI");
    $this.Draw_Cone01_Drawable0_View3x3_3_29_0_ldElqMfXuE = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "View3x3_3_29_0_ldElqMfXuE");
    $this.Draw_Cone01_Drawable0_textureMap_13_4_0_zyaIGHcelM = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "textureMap_13_4_0_zyaIGHcelM");
    $this.Draw_Cone01_Drawable0_envMap_13_5_0_GAdnSndlEw = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "envMap_13_5_0_GAdnSndlEw");
    $this.Draw_Cone01_Drawable0_envMap2_13_6_0_WhPbTTohYp = gl.getUniformLocation($this.Draw_Cone01_Drawable0_prog, "envMap2_13_6_0_WhPbTTohYp");
    return $this;
};
